'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

var tslib = require('tslib');
var t = require('path');
var a = require('ms');
var s = require('flat-cache');
var c = require('debug');
var o = require('assert');

function _interopDefaultLegacy (e) { return e && typeof e === 'object' && 'default' in e ? e : { 'default': e }; }

var t__default = /*#__PURE__*/_interopDefaultLegacy(t);
var a__default = /*#__PURE__*/_interopDefaultLegacy(a);
var s__default = /*#__PURE__*/_interopDefaultLegacy(s);
var c__default = /*#__PURE__*/_interopDefaultLegacy(c);
var o__default = /*#__PURE__*/_interopDefaultLegacy(o);

var i = c__default['default']("presta-cache"),
    p = process.cwd(),
    n = t__default['default'].resolve(p, "./.presta/cache"),
    h = s__default['default'].load("presta", t__default['default'].resolve(p, "./.presta/cache"));

function m(t, s) {
  return tslib.__awaiter(this, void 0, void 0, function () {
    var e, c, p, n, m, f, u;
    return tslib.__generator(this, function (r) {
      switch (r.label) {
        case 0:
          if (e = s.key, c = s.duration, o__default['default'](!!e, "@presta/cache expects a key"), o__default['default'](!!c, "@presta/cache expects a duration"), p = a__default['default'](c), n = h.getKey(e), m = Date.now(), n) {
            if (f = n.expires, !(m > f)) return i(e + " is cached"), [2, n.value];
            i(e + " has expired"), h.removeKey(e);
          }

          return [4, t()];

        case 1:
          return u = r.sent(), h.setKey(e, {
            value: u,
            expires: m + p
          }), h.save(!0), i(e + " has been cached for " + c), [2, u];
      }
    });
  });
}

i("@presta/cache at " + n);

var _id = 0;
var _reqs = [];
var _cache = {};

function isPending() {
  return !!_reqs.length;
}

function resolve() {
  var requests = Object.keys(_cache).map(function (key) {
    return _cache[key];
  }); // @ts-ignore

  return Promise.allSettled(requests).then(function () {
    _id = 0;
    _reqs = [];
  });
}

function cache(key, loader) {
  if (_cache[key]) return _cache[key];

  _reqs.push(key);

  _cache[key] = loader();

  _cache[key].then(function (res) {
    _cache[key] = res;

    _reqs.splice(_reqs.indexOf(key), 1);
  });

  return null;
}

function load(loader, options) {
  if (options === void 0) {
    options = {};
  }

  var _a = options.key,
      key = _a === void 0 ? _id++ + "" : _a,
      duration = options.cache;

  if (key && duration) {
    return cache(key, function () {
      return m(loader, {
        key: key,
        duration: duration
      });
    });
  }

  return cache(key, loader);
}
function render(component, ctx, renderer) {
  return tslib.__awaiter(this, void 0, void 0, function () {
    var body;
    return tslib.__generator(this, function (_a) {
      switch (_a.label) {
        case 0:
          body = renderer(component, ctx);
          if (!isPending()) return [3
          /*break*/
          , 2];
          return [4
          /*yield*/
          , resolve()];

        case 1:
          _a.sent();

          return [2
          /*return*/
          , render(component, ctx, renderer)];

        case 2:
          _reqs = [];
          return [2
          /*return*/
          , tslib.__assign(tslib.__assign({}, ctx), {
            body: body + (ctx.body || ''),
            data: tslib.__assign(tslib.__assign({}, _cache), ctx.data || {})
          })];
      }
    });
  });
}

exports.load = load;
exports.render = render;
